//**********************all.h***********************************************
#ifndef _ALL_H_
#define _ALL_H_

#include <iostream>
#include <vector>
using namespace std;

class Tree{
public:
	int data;
	Tree * left;
	Tree * right;
	Tree(int data){this->data = data; left = right = NULL;}
};

void inorder(Tree * t);

void mergesort(vector<char> & array,int begin,int end);
void merge(vector<char> & array,int begin,int mid,int end); 

void qsort(vector<char> & array,int begin,int end);
int partition(vector<char> & array,int begin,int end);

#endif
//**********************r2nr.cpp***********************************************
#include "all.h"

void main()
{
	/*
	Tree * s = new Tree(1);
	s->left = new Tree(2);
	s->right = new Tree(3);
	inorder(s);
	*/
	/*
	vector<char> s;
	s.push_back(9);
	s.push_back(4);
	s.push_back(7);
	s.push_back(5);
	qsort(s,0,3);

	for(int count = 0;count <= 3;count++)
		cout << (int)s[count] << endl;
	*/
	vector<char> s;
	s.push_back(9);
	s.push_back(4);
	s.push_back(7);
	s.push_back(5);
	mergesort(s,0,3);

	for(int count = 0;count <= 3;count++)
		cout << (int)s[count] << endl;
}
//*************************inorder.cpp********************************************
#include "all.h"


void inorder(Tree * t)
{
	vector<Tree *> mystk;
	Tree * tmp;

START:
	if(t == NULL)
		goto RETURN;

	cout << t->data << endl;

	mystk.push_back(t);
	t = t->left;
	goto START;

RETURN:
	if(mystk.size() == 0)
		return;
	
	tmp = mystk[mystk.size() - 1];
	mystk.pop_back();
	t = tmp->right;
	goto START;
}
//***************************qsort.cpp******************************************
#include "all.h"


void qsort(vector<char> & array,int begin,int end)
{
	vector<int> mystk;
	int q;

START:
	if(end <= begin)
		goto RETURN;

	q = partition(array,begin,end);

	mystk.push_back(q);
	mystk.push_back(begin);
	mystk.push_back(end);
	end = q -1;
	goto START;

RETURN:
	if(mystk.size() == 0)
		return;

	end = mystk[mystk.size() - 1];
	mystk.pop_back();
	begin = mystk[mystk.size() - 1];
	mystk.pop_back();
	q = mystk[mystk.size() - 1];
	mystk.pop_back();

	begin = q + 1;
	goto START;
}


int partition(vector<char> & array,int begin,int end)
{
	char x = array[begin];
	int i = begin - 1;
	int j = end + 1;

	while(true)
	{
		do
		i++;
		while(array[i] <= x && i < j);

		do
		j--;
		while(array[j] > x && i < j);

		if(i < j)
			swap(array[i],array[j]);
		else
		{
			swap(array[begin],array[i - 1]);
			return i - 1;
		}
	}
}
//************************merge.cpp*********************************************
#include "all.h"

void mergesort(vector<char> & array,int begin,int end)
{
	vector<int> mystk;
	int mid;
	int retaddr;
START:
	if(begin >= end)
		goto RETURN;

	mid = (begin + end) / 2;

	mystk.push_back(begin);
	mystk.push_back(mid);
	mystk.push_back(end);
	mystk.push_back(1);//retaddr

	end = mid;
	goto START;

RETURN:
	while(mystk.size() != 0)
	{
		retaddr = mystk[mystk.size() - 1];
		mystk.pop_back();

		switch(retaddr)
		{
		case 1:
			end = mystk[mystk.size() - 1];
			mystk.pop_back();
			mid = mystk[mystk.size() - 1];
			mystk.pop_back();
			begin = mystk[mystk.size() - 1];
			mystk.pop_back();
			mystk.push_back(begin);
			mystk.push_back(mid);
			mystk.push_back(end);
			mystk.push_back(2);//retaddr
			begin = mid + 1;
			goto START;
			break;
		case 2:
			end = mystk[mystk.size() - 1];
			mystk.pop_back();
			mid = mystk[mystk.size() - 1];
			mystk.pop_back();
			begin = mystk[mystk.size() - 1];
			mystk.pop_back();
			merge(array,begin,mid,end);
			break;
		default:
			cout << "CHAND TA FOHSH E BAD!!" << endl;
			break;
		}
	}
}

void merge(vector<char> & array,int begin,int mid,int end)
{
	vector<char> tmp;
	int i = begin;
	int j = mid + 1;
	int tammat = end - begin + 1;
	int count;

	for(count = 0;count < tammat && i != mid + 1 && j != end + 1;count++)
	{
		int a = array[i];
		int b = array[j];
		if(array[i] < array[j])
		{
			tmp.push_back(array[i]);
			i++;
		}
		else
		{
			tmp.push_back(array[j]);
			j++;
		}
	}

	if(i != mid + 1)
	{
		int a = array[i];
		for(;count < tammat;count++)
			tmp.push_back(array[i++]);
	}

	if(j != end + 1)
	{
		int b = array[j];
		for(;count < tammat;count++)
			tmp.push_back(array[j++]);
	}
	
	int counter;

	for(count = begin,counter = 0;count <= end;count++,counter++)
		array[count] = tmp[counter];
}
//*****************************:)))****************************************
